<template>
  <div class = 'CourseInfo'>
    <vue-particles
      color='#3498db'
      :particleOpacity='0.7'
      :particlesNumber='80'
      shapeType='circle'
      :particleSize='4'
      linesColor='#3498db'
      :linesWidth='1'
      :lineLinked='true'
      :lineOpacity='0.4'
      :linesDistance='150'
      :moveSpeed='4'
      :hoverEffect='true'
      hoverMode='grab'
      :clickEffect='true'
      clickMode='push'
    >
    </vue-particles>
    <el-row style='width: 100%;'>
      <el-row class = 'topHeader'>
        <OurHeader/>
      </el-row>
      <el-container style='width: 60%; margin: 0px auto 0px auto; padding-bottom: 10px'>
        <el-header style='height: 300px; margin-top: 10px'>
          <el-row  height='300px' class='courseBasic'>
            <el-col :span=12>
              <el-image
              :src='getPic(course_id)' 
              fit='contain'
              class='courseImg'>
                <div slot="error" class="image-slot">
                  <i class="el-icon-picture-outline"></i>
                </div>
              </el-image>
            </el-col>
            <el-col :span=12 style='float: left; padding-left: 40px;'>
              <el-row class='courseTitle' type='flex' justify='start'>
                {{courseTitle}}
              </el-row>
              <div class='basicInfo'>
                <el-row class='basicInfoType' type='flex' justify='start'>
                课程时间：{{getCourseTime()}}
                </el-row>
                <el-row class='basicInfoType' type='flex' justify='start'>
                课程学分：{{credit}}
                </el-row>
                <el-row class='basicInfoType' type='flex' justify='start'>
                授课教师：{{teacher}}
                </el-row>
                <el-row class='basicInfoType' type='flex' justify='start' v-if='outlineLength'>
                考核方式：{{assessment}}
                </el-row><el-row class='basicInfoType' type='flex' justify='start' v-else>
                上课地点：{{getCoursePlace()}}
                </el-row>
              </div>
            </el-col>
          </el-row>
        </el-header>
        <el-main class='main'>
          <el-tabs>
            <el-tab-pane label="课程信息">
              <div style="text-align: left; margin: 10px 0px 10px 30px">
              <span>标签：</span>
              <el-tag
                v-for="item in labels"
                :key= 'item.text'
                effect = 'plain'
                style = 'margin-left: 5px'>
                {{ item.text }}
              </el-tag>
              </div>
              <div class='teacherMessage' v-if='hasMessage'>
                <p class='basicInfoType'>
                教师的话：
                </p>
                <p class='basicInfoType'>
                {{teacherMessage}}
                </p>
              </div>
              <div class='courseIntro'>
                <h3>
                  <i class='el-icon-menu' style='color: rgb(153, 204, 255)'></i>
                  课程概述
                </h3>
                <p>
                  {{courseIntro}}
                </p>
              </div>
              <div class='courseIntro'>
                <h3 style='text-align: left'>
                  <i class='el-icon-s-claim' style='color: rgb(153, 204, 255)'></i>
                  课程大纲
                </h3>
                <el-timeline style='margin-top: 30px'>
                  <el-timeline-item
                    v-for='(it, index1) in outline'
                    :key='index1'
                    :timestamp='it.content'>
                    {{it.title}}
                  </el-timeline-item>
                </el-timeline>
              </div>
              <el-button v-if='high_privelege' @click='EditCheck()'>编辑课程信息</el-button>
              <el-dialog title='编辑课程信息' :visible.sync='editCourseInfo'>
                
                <p style='text-align: left'> 教师的话： </p>
                <el-input
                  type = 'textarea'
                  :rows = '2'
                  placeholder = '请输入教师的话'
                  v-model = 'teacherMessage'>
                </el-input>
                <el-divider></el-divider>

                <p style='text-align: left'> 课程标签: </p>
                <div v-for='(item, index2) in labels' :key='index2'>
                  <el-row>
                    <el-col :span='8' :offset='8'>
                      <el-input v-model='item.text' placeholder="请输入内容"></el-input>
                    </el-col>
                  </el-row>
                </div>
                <el-button @click = 'addLabel()'>添加一行</el-button>
                <el-button @click = 'labels.pop()'>删除一行</el-button>
                <el-divider></el-divider>

                <p style='text-align: left'> 课程概述: </p>
                <el-input
                  type = 'textarea'
                  :rows = '2'
                  placeholder = '请输入课程概述'
                  v-model = 'courseIntro'>
                </el-input>
                <el-divider></el-divider>

                <p style='text-align: left'> 课程大纲: </p>
                <div v-for='(item, index3) in outline' :key='index3'>
                  <el-row>
                    <el-col :span = '2'> 
                      <p>标题：</p> 
                    </el-col>
                    <el-col :span = '8'>
                      <el-input v-model='item.title' placeholder="请输入内容"></el-input>
                    </el-col>
                    <el-col :span = '2'>
                     <p>概要：</p>
                    </el-col>
                    <el-col :span = '10'>
                      <el-input v-model='item.content' placeholder="请输入内容"></el-input>
                    </el-col>
                  </el-row>
                </div>
                <el-button @click = 'addOutline()'>添加一行</el-button>
                <el-button @click = 'outline.pop()'>删除一行</el-button>
                <div slot='footer' class='dialog-footer'>

                  <el-button type = 'primary' @click='UpdateCourseinfo()'>提交修改</el-button>
                </div>
              </el-dialog>
              
            </el-tab-pane>
            <el-tab-pane label='课程评价'>
              <div class='courseScore'>
                <h3>
                    <i class='el-icon-s-data' style='color: rgb(153, 204, 255)'></i>
                    课程评分
                </h3>
                <el-rate
                  :value='aveScore'
                  disabled
                  show-score
                  text-color="#ff9900"
                  score-template="{value}">
                </el-rate>
              </div>
              <div class='courseScore'>
                <h3>
                    <i class='el-icon-s-custom' style='color: rgb(153, 204, 255)'></i>
                    精选评论
                </h3>
              </div>
              <div class='commentsBlock'>
                <div class = 'comment' v-for='(comment, index4) in comments' :key='index4'>
                  <el-row>
                    <el-col :span=3>
                      <el-image 
                      :src='comment.comment_avatar'
                      fit='fill'
                      class='profile'>
                      </el-image>
                    </el-col>
                    <el-col :span=9 style='text-align: left'>
                      <p style='font-weight: bold'>
                        {{comment.user_id}}
                      </p>
                      <p>
                        {{comment.content}}
                      </p>
                      <p style='color:#888; font-size: 12px'>
                        评价时间：{{ getTime(comment.time) }}
                      </p>
                      <el-button v-if='admin_privelege' v-on:click='DeleteComment(index4)' type="danger" size='mini' plain style="margin:0px 0px 0px 0px;">删除评论</el-button>
                    </el-col>
                    <el-col :span=12 style='text-align: right; margin-top: 50px'>
                      <el-rate
                        v-model='comment.score'
                        disabled
                        text-color="#ff9900"
                        score-template="{value}">
                      </el-rate>
                    </el-col>
                  </el-row>
                </div>
              </div>
              <el-button @click='AddCheck()' style='margin-top: 20px'>添加评论</el-button>
              <el-dialog title='添加评论' :visible.sync='addcomment_vis'>
                <el-input
                  type = 'textarea'
                  :rows = '5'
                  placeholder = '请输入评论内容'
                  v-model = 'newComment'>
                </el-input>
                <div slot='footer' class='dialog-footer'>
                  <el-button @click = 'addcomment_vis = false'>取 消</el-button>
                  <el-button type = 'primary' @click='AddComment()'>提 交</el-button>
                </div>
                <div style = "margin-top: 30px;">
                  <span class="demonstration">为课程打分</span>
                  <el-rate v-model="newCommentScore"></el-rate>
                </div>
              </el-dialog>
            </el-tab-pane>
            <el-tab-pane label='课程问答'>
                <ForumView v-if='defaultforum' @enterpost='EnterPost' :cid='this.course_id'></ForumView>
                <PostView v-else @enterforum='defaultforum=true;' :pid='post_id'> </PostView>
            </el-tab-pane>
          </el-tabs>
        </el-main>
      </el-container>
    </el-row>
  </div>
</template>

<script>

import OurFooter from '@/components/common/OurFooter.vue';
import OurHeader from '@/components/common/OurHeader.vue';
import ForumView from '@/views/ForumView.vue';
import PostView from '@/views/PostView.vue';

export default {
  name: 'CourseInfo',
  data() {
    return {
      tongjiIcon: require('../assets/images/tongjiIcon.png'),
      //courseImg: require('../assets/images/courseImg.png'),
      //errorImage: 'this.src="' + require('../assets/images/error.png') + '"',
      course_id: '',
      courseTitle: '课程不存在',
      courseTime: '暂无',
      credit: 0,
      teacher: '暂无',
      assessment: '',
      hasMessage: false,
      teacherMessage: '',
      courseIntro: '还未发布课程介绍',
      outline: [],
      courseId: '',

      labels: [
        {text: 'haoke'},
        {text: 'huaike'}
      ],
      place: '',
      type: '',
      language: '',
      department: '',

      day: 0,
      period: 0,
      value1: [''],
      room: '',


      editCourseInfo: false,
      newCourseInfo: '',
      addcomment_vis: false,
      newComment: '',
      newCommentScore: null,
      comments: [],

      defaultforum : true,
      post_id : '',

      contain : '',
      fill : '',

      cur_user : this.$store.getters.getEmail.slice(0,7),
      high_privelege : this.$store.getters.getRole=='admin' || this.$store.getters.getRole=='teacher',
      admin_privelege : this.$store.getters.getRole=='admin',
    };
  },
  created() {
    this.getCourseId();
    this.getBasicCourseinfo();
    this.getCourseinfo();
    this.GetComment();
  },
  computed: {
    aveScore() {
      var sum=0;
      var cnt=0;
      this.comments.forEach(item=>{
        cnt = cnt + 1;
        sum = sum + item.score;
      });
      return Number((sum / cnt).toFixed(1));
    },
    outlineLength() {
      var cnt = 0;
      for(var x in this.outline)
        cnt ++;
      return cnt;
    }
  },
  methods: {
    EnterPost(post_id){
      this.defaultforum = false;
      this.post_id = post_id;
    },

    EditCheck(){
      if(this.high_privelege){
        this.editCourseInfo = true; 
      }
      else{
        this.$message('仅教师与管理员具有修改权限');
      }
    },
    getAvatar(index,user_id){
      this.$axios.get('/api/user/info',{
        params:{
          email : user_id + '@tongji.edu.cn',
        }
      })
        .then((response)=>{
          this.comments[index].comment_avatar = response.data.data.avatar;
          this.$forceUpdate();
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    addLabel() {
      var label = {};
      label['text'] = '';
      this.labels.push(label);
    },
    getCourseTime() {
      if(this.credit > 0 || this.day == 0)
        return this.courseTime;
      var li = ['一', '二', '三', '四', '五', '六', '日'];
      var res = '周';
      res = res + li[this.day - 1] + ' ';
      res = res + this.period + '-' + (this.period + 1);
      this.credit = 2;
      return res;
    },
    getCourseId() {
      this.course_id = this.$route.params.courseId;
      this.value1[0] = this.course_id;
    },
    getCoursePlace() {
      var res = this.place;
      res = res + ' ' + this.room;
      return res;
    },
    getTime(x) {
      return new Date(parseInt(x)).toLocaleString().replace(/:\d{1,2}$/,' '); 
    },
    getPic(pic_name) {
      if(this.assessment.length == 0)
        return require('../assets/images/error.png');
      var pic = require('../assets/images/' + pic_name + '.png');
      return pic;
    },
    addOutline() {
      var obj = {};
      obj['title'] = '';
      obj['content'] = '';
      this.outline.push(obj);
    },
    AddCheck(){
      let cur_user = this.$store.getters.getEmail.slice(0,7);
      var check = false;
      this.comments.forEach(item => {
        if(item.user_id == cur_user){
          check = true;
        }
      });
      if(!check && !this.high_privelege){
        this.addcomment_vis = true;
      }
      else if(this.high_privelege){
        this.$message('教师与管理员无法发布评论');
      }
      else if(check){
        this.$message('您已进行过评论');
      }
    },

    getBasicCourseinfo() {
      var url = '/api/courses/get-courses';
      this.$axios.get(url,
        {
          params:{
            _id: this.value1,
          }
        }).then(response => {
        if(response.data.courses.length>0){
          this.courseTitle = response.data.courses[0].name;
          this.day = response.data.courses[0].day;
          this.period = response.data.courses[0].period;
          this.teacher = response.data.courses[0].teacher;
          this.place = response.data.courses[0].place;
          this.room = response.data.courses[0].room;
          this.department = response.data.courses[0].department;
          this.type = response.data.courses[0].type;
          this.language = response.data.courses[0].language;
        }
        //this.credit = 2;

      }, response => {
        console.log('error');
      });
    },
    getCourseinfo() {
      var url = '/api/courseinfo/get-courseinfo';
      this.$axios.get(url,
        {
          params:{
            course_id: this.course_id,
          }
        }).then(response => {
        this.courseTitle = response.data.courseTitle;
        this.courseTime = response.data.courseTime;
        this.credit = response.data.credit;
        this.teacher = response.data.teacher;
        this.assessment = response.data.assessment;
        this.teacherMessage = response.data.teacher_message;
        this.hasMessage = response.data.hasMessage;
        this.courseIntro = response.data.course_intro;
        this.outline = response.data.outline;
        this.labels = response.data.labels;
        this.$forceUpdate();
      }, response => {
        // console.log('error');
      });
    },
    GetComment() {
      var url = '/api/comment/get-comment';
      this.$axios.get(url,
        {
          params:{
            course_id: this.course_id,
            idx_type: 0
          }
        }).then(response => {
        this.comments = response.data.comment_list;
        let i = 0;
        this.comments.forEach(element => {
          this.getAvatar(i,element.user_id);
          i+=1;
        });
        this.$forceUpdate();
      }, response => {
        // console.log('error');
      });
    },
    AddComment() {
      if(!this.high_privelege && this.newComment.length> 0 && this.newCommentScore > 0){
        this.$axios.post('/api/comment/add-comment',{
          course_id : this.course_id,
          user_id : this.$store.getters.getEmail.slice(0,7),
          score : this.newCommentScore,
          content : this.newComment,
          timestamp : 10000,
        })
          .then((response)=>{
            this.newComment = '';
            this.newCommentScore = null;
            this.GetComment();
          })
          .catch((error)=>{
            console.log(error);
          });
        this.addcomment_vis = false; 
      }
      else if(this.newComment.length<=0){
        this.$message('请先输入课程评价');
      }
      else if(this.newCommentScore<=0){
        this.$message('请为课程打分');
      }
    },
    DeleteComment(index) {
      let comment_id = this.comments[index]._id;
      let poster_id = this.comments[index].user_id;
      if(this.$store.getters.getRole=='admin' || this.cur_user==poster_id){
        this.$axios.post('/api/comment/delete-comment',{
          comment_id : comment_id,
          user_id : this.cur_user,
          timestamp : 10000,
        })
          .then((response)=>{
            this.GetComment();
          })
          .catch((error)=>{
            console.log(error);
          });
      }
      else{
        this.$message('仅管理员与发布者具有删除权限');
      }
    },
    UpdateCourseinfo(){
      var temp_record = ['0'];
      let check_null = false;
      for(var i=0;i<this.labels.length;i++){
        temp_record.push(this.labels[i].text);
        if(this.labels[i].text=='')
          check_null = true;
      }
      let check_dup = false;
      for(i=0;i<temp_record.length;i++){
        if(temp_record.indexOf(temp_record[i])!=temp_record.lastIndexOf(temp_record[i]))
          check_dup = true;
      }
      if(this.high_privelege && !check_dup && !check_null){
        this.$axios.post('/api/courseinfo/update-courseinfo',{
          course_id : this.course_id,
          user_id : this.cur_user,
          course_intro : this.courseIntro,
          teacher_message : this.teacherMessage,
          outline : this.outline,
          labels : this.labels,
        })
          .then((response)=>{
            this.getCourseinfo();
          })
          .catch((error)=>{
            console.log(error);
          });
        this.editCourseInfo = false; 
      }
      else if(check_dup){
        this.$message('不能添加重复标签');
      }
      else if(check_null){
        this.$message('不能添加空标签');
      }
    },
  },
  components: {
    ForumView,
    PostView,
    OurFooter,
    OurHeader
  }
};
</script>

<style scoped>

.CourseInfo {
}

.topHeader {
  background-color: #f8f8f8;
  height: 7%;
}

.sideBar {
  background: #fff;
  margin-right: 10px;
  text-align: left;
}

.courseBasic {
  box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  padding: 10px 20px 20px 20px;
  background: #fff;
  border-radius: 12px
}

.main {
  margin-left: 20px;
  margin-right: 20px;
  background: #fff;
  border-radius: 12px
}

.tongjiIcon {
  color: #1c98ce; 
  font-size: 20px; 
  font-weight:bold;
  text-align: left;
}

.courseImg {
  margin-top: 45px;
  width: 300px;
}

.basicInfo {
  background: #f8f8f8;
  padding: 10px;
  border-radius: 8px;
  width: 80%;
}

.basicInfoType {
  margin: 10px 0px 10px 10px;
  font-size: 14px;
}

.courseTitle {
  margin-top: 50px;
  margin-bottom: 20px;
  font-size: 24px;
  font-weight:bold;
}

.teacherMessage {
  background: rgb(223,245,255);
  margin: 20px 30px 20px 30px;
  padding: 20px 30px 20px 30px;
  border-radius: 8px;
  text-align: left;
}

.courseIntro {
  margin: 20px 30px 20px 30px;
  text-align: left;
}

.commentsBlock {
  margin: 20px 50px 20px 50px;
  text-align: left;
}

.comment {
  margin: 5px 0px 5px 0px;
  padding: 20px 20px 20px 20px;
  font-size: 14px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, .12), 0 0 6px rgba(0, 0, 0, .04);
}

.profile {
  margin-top: 15px;
  border-radius: 100px;
  width: 50px;
  height: 50px;
}

.courseScore {
  margin: 30px 30px 20px 30px;
  text-align: left;
}

/deep/.el-rate__icon{
  font-size: 28px;
}

#particles-js{
  width: 100%;
  height: 150%;
  position: absolute;
}

</style>
